/**
  * =========================================================================
  *  Copyright (C) since 1995 by Leidson CAF & PlanetaMessenger.org
  *
  *  This module is developed and maintained by PlanetaMessenger.org. 
  *  Specs, New and updated versions can be found in 
  *  http://www.planetamessenger.org
  *  If you want contact the Team please send a email to Project Manager
  *  Leidson Campos Alves Ferreira at leidson@planetamessenger.org
  *
  *  Copyright (C) since 1995 by PlanetaMessenger.org
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation; either version 2 of the License, or
  *  (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU General Public License for more details.
  *
  *  You should have received a copy of the GNU General Public License
  *  along with this program; if not, write to the Free Software
  *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  * ===========================================================================
  */

/**
  *
  * $Id: tui.h 49 2011-03-09 00:14:32Z popolony2k $
  * $Author: popolony2k $
  * $Date: 2011-03-09 00:14:32 +0000 (Wed, 09 Mar 2011) $
  * $Revision: 49 $
  * $HeadURL: file:///svn/p/oldskooltech/code/msx/trunk/tools/cpp/sound/mml2msd/tui.h $
  */
  
#ifndef __TUI_H__
#define __TUI_H__

#include <string>
#include <vector>

using namespace std;


/**
  * Argument vector type.
  */
typedef vector<string> ArgV;


class TUI  {
  
  bool         bFindTempo;
  bool         bVerbose;
  bool         bRemoveInstruments;
  bool         bInvalidArguments;
  bool         bHelp;
  bool         bRemarks;
  string       strCustomMML;
  string       strCustomMMLFileName;
  string       strOutputFileName;
  string       strInputFileName;
  string       strLastError;


  void ParseArgs( ArgV args );
  
  public:
    
  TUI( ArgV argv );
  ~TUI( void );
  
  bool GetFindTempo( void );
  bool GetVerbose( void );
  bool GetRemarks( void );
  bool GetRemoveInstruments( void );
  bool GetHelp( void );
  bool HasInvalidArguments( void );
  bool HasCustomMML( void );
  bool HasCustomMMLFileName( void );

  string GetCustomMML( void );
  string GetCustomMMLFileName( void );
  string GetOutputFileName( void );
  string GetInputFileName( void );
  string GetLastError( void );

  static void ShowHeader( void );
  static void ShowHelp( void );
  
};

#endif  // __TUI_H__
